#include "Call.h"
#include <stdio.h>

#include "resip/dum/InviteSession.hxx"
#include "resip/dum/ClientInviteSession.hxx"

using namespace resip;

Call::Call(resip::DialogUsageManager &dum):AppDialogSet(dum)
{
    this->mRtpSession = 0;
    this->mIncomming = false;
}

Call::~Call()
{
    if (this->mRtpSession)
    {
        delete this->mRtpSession;
        this->mRtpSession = 0;
    }
}

void Call::setIncomming(bool i)
{
    this->mIncomming = i;
}

void Call::addRTPObserver(RTPObserver *obs)
{
    this->mRtpObservers.push_back(obs);
}


void Call::setRTPSession(RTPSession *rtpSession)
{
    this->mRtpSession = rtpSession;
    this->mRtpSession->addObserver(this); //TODO should unsubscribe if overwriting observer
}

RTPSession* Call::getRTPSession()
{
    return this->mRtpSession;
}

void Call::onSoundQueueEmpty()
{
    for (std::list<RTPObserver*>::iterator it = this->mRtpObservers.begin();it!=this->mRtpObservers.end();it++)
    {
        (*it)->onRTPSessionSoundQueueEmpty(this);
    }

}

bool Call::isIncomming()
{
    return this->mIncomming;
}

std::string Call::getDigitQueue()
{
    return this->mDigitQueue;
}

void Call::clearDigitQueue()
{
    this->mDigitQueue="";
}

