#ifndef IVR_H
#define IVR_H

#include <string>
#include <list>
#include <map>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "IVRStep.h"

enum IVRResult
{
    WaitingForMore,
    SwitchStep,
    HangupCall,
    Terminated    
};

class IVR{
private:
    IVRStep* mRootStep;
    IVRStep* mCurrentStep;
    std::map<std::string,std::string> mUserData;

    IVRStep *getIVRStepFromXml(xmlNode * a_node);
    void showIVR(IVRStep* step);

public:

	IVR(std::string xmlFile);
	~IVR();

    std::string getPrompt();
    int getNumDigits();

    IVRResult onDigits(std::string digits);

    std::string getUserData(std::string key);
};

#endif

