#ifndef IVRSTEP_H
#define IVRSTEP_H

#include <string>
#include <list>
enum IVRAction
{
    None,
    Transfer, //not supported yet
    Hangup,
    NoSubStep
};

class IVRStep{
private:
    std::string mPrompt; //only support 1 prompt for now
    std::string mPattern;
    std::string mKeep;  // name of entry in which we should keep the digits that the user entered.
    IVRAction mAction;
    std::list<IVRStep*> mSteps;
public:
    // pattern is what needs to be matched to enter this step. prompt will be 
    // played once we anter this step, and the digits AFTER entering this step
    // will be kept in variable called "keep"
	IVRStep(std::string prompt, std::string pattern, std::string keep, IVRAction action);
    IVRStep();
	~IVRStep();

    void setPrompt(std::string prompt);
    void setPattern(std::string pattern);
    void setKeep(std::string keep);
    void setAction(IVRAction action);

    void addSubStep(IVRStep* step);
    std::string getPrompt();
    bool matches(std::string string);
    IVRStep* onDigits(std::string digits);
    IVRAction getAction();

    std::string getKeepName();
    std::string toString();
    std::list<IVRStep*> getSteps();
};

#endif

